var fs = require('fs');
var path = require('path');
var glob = require('glob');

var destLang;

// Compare objects in the source & dest file
var compareObject = function(srcObj, destObj) {
  // 1. Loop over through source object
  for (var prop in srcObj) {
    // 2. Check whether the property exist in destination json file
    if (destObj.hasOwnProperty(prop)) {
      if (typeof srcObj[prop] === 'object') {
        compareObject(srcObj[prop], destObj[prop]);
      }
    } else {
      // 3. If property doesn't exist in destination json insert it
      if (typeof srcObj[prop] !== 'object') {
        destObj[prop] = srcObj[prop];
      } else {
        destObj[prop] = updateProperty(srcObj[prop]);
      }
    }
  }
  return destObj;
};

// Update property value with language extension
var updateProperty = function (object) {
  for (var prop in object) {
    if (typeof object[prop] === 'object') {
      updateProperty(object[prop]);
    } else {
      object[prop] = object[prop];
    }
  }
  return object;
};

// Compares & updates the JSON file
var readAndUpdateJson = function (srcLangFilePath, destPath) {
  // To read files matched with given path
  var arrFiles = glob.sync(destPath);
  for (var i = 0; i < arrFiles.length; i++) {
    if (arrFiles[i] !== srcLangFilePath) {
      var objSrcLang = JSON.parse(fs.readFileSync(srcLangFilePath, 'utf8'));
      var objDestLang = JSON.parse(fs.readFileSync(arrFiles[i], 'utf8'));
      destLang = path.basename(arrFiles[i], '.json').toUpperCase();
      var objProcessedData = compareObject(objSrcLang, objDestLang);

      // Prettify & write into the file
      fs.writeFileSync(arrFiles[i], JSON.stringify(objProcessedData, null, 2));
    }
  }
};

module.exports = readAndUpdateJson;
